src/AppBundle/Entity/Commentaire.php
<?php
//Class Commentaire

namespace AppBundle\Entity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity
 * @ORM\Table(name="cinefilms.Commentaire")
 */
class Commentaire
{
    /**
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;
  
    /**
     * @ORM\Column(name="contenu", type="text", nullable=false)
     */
    private $contenu;

    /**
     * @ORM\Column(name="datecreation", type="datetime", nullable=false)
     */
    private $datecreation;
  
    /**
     * @ORM\ManyToOne(targetEntity="AppBundle\Entity\Film", inversedBy="commentaires")
     * @ORM\JoinColumn(nullable=false)
     */
    private $film;
  
    /**
     * @ORM\ManyToOne(targetEntity="AppBundle\Entity\Utilisateur", inversedBy="commentaires")
     * @ORM\JoinColumn(nullable=false)
     */
    private $utilisateur;
     
    


    /**
     * Getter et Setter pour Id
     */
    public function getId()
    {
        return $this->id;
    }
    function setId($id){
        $this->id = $id; //Permet de determiner une valeur pour l'objet Id
    }
  
    /**
     * Getter et Setter pour Contenu
     */
    public function setContenu($contenu)
    {
        $this->contenu = $contenu;

        return $this;
    }

    public function getContenu()
    {
        return $this->contenu;
    }

    /**
     * Getter et Setter pour DateCreation
     */
    public function setDateCreation($datecreation)
    {
        $this->datecreation = $datecreation;

        return $this;
    }
  
    public function getDateCreation()
    {
        return $this->datecreation;
    }
  
    /**
     * Getter et Setter pour Film
     */
    public function setFilm($film)
    {
        $this->film = $film;

        return $this;
    }
  
    public function getFilm()
    {
        return $this->film;
    }
  
    /**
     * Getter et Setter pour Utilisateur
     */
    public function setUtilisateur($utilisateur)
    {
        $this->utilisateur = $utilisateur;

        return $this;
    }
  
    public function getUtilisateur()
    {
        return $this->utilisateur;
    }
    

}

src/AppBundle/Entity/Film.php
<?php
//Class Film.php

namespace AppBundle\Entity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;



/**
 * @ORM\Entity
 * @ORM\Table(name="cinefilms.Film")
 */  

class Film{
    /**
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;
    
    /**
     * @ORM\Column(name="titre", type="string", nullable=false)
     */
    private $titre;
    
    /** 
     * @ORM\Column(name="annee", type="integer", nullable=false)
     */
    private $annee;
  
    /**
     * @ORM\Column(name="image", type="string", nullable=false)
     * @Assert\Url()
     */
    private $image;
    
    /**
     * @ORM\Column(name="synopsis", type="text", nullable=false)
     */
    private $synopsis;
    
    /**
     * @ORM\Column(name="duree", type="integer", nullable=false)
     */
    private $duree;
  
    /**
     * @ORM\ManyToOne(targetEntity="AppBundle\Entity\Genre", inversedBy="films")
     * @ORM\JoinColumn(nullable=false)
     */
    private $genre;
  
    /**
     * @ORM\ManyToOne(targetEntity="AppBundle\Entity\Pays", inversedBy="filmpays")
     * @ORM\JoinColumn(nullable=false)
     */
    private $pays;
  
    /**
     * @ORM\OneToMany(targetEntity="AppBundle\Entity\PersonneFilm", mappedBy="film")
     */
    private $filmspersonnes;
  
    /**
     * @ORM\OneToMany(targetEntity="AppBundle\Entity\Commentaire", mappedBy="film")
     */
    private $commentaires;
  
  
  
    public function __construct() // Fonction 
    {
        $this->commentaires = new ArrayCollection();
        $this->filmspersonnes = new ArrayCollection();
    }
    //Accesseurs
  
    //Getters et setters pour l'objet Id
    public function getId(){
        return $this->id; //Retourne en lecture l'objet Id
    }
    public function setId($id){
        $this->id = $id; //Permet de determiner une valeur pour l'objet Id
    }

    //Getters et setters pour l'objet Titre
    public function getTitre(){
        return $this->titre; //Retourne en lecture l'objet Titre
    }
    public function setTitre($titre){
        $this->titre = $titre; //Permet de determiner une valeur pour l'objet Titre
    }

    //Getters et setters pour l'objet Annee
    public function getAnnee(){
        return $this ->annee; //Retourne en lecture l'objet Annee
    }
    public function setAnnee($annee){
        $this->annee = $annee; //Permet de determiner une valeur pour l'objet Annee
    }
  
    //Getters et setters pour l'objet Image
    public function getImage(){
        return $this ->image; //Retourne en lecture l'objet Image
    }
    public function setImage($image){
        $this->image = $image; //Permet de determiner une valeur pour l'objet Image
    }

    //Getters et setters pour l'objet Synopsis
    function getSynopsis(){
        return $this ->synopsis; //Retourne en lecture l'objet Synopsis
    }
    function setSynopsis($synopsis){
        $this->synopsis = $synopsis; //Permet de determiner une valeur pour l'objet Synopsis
    }

    //Getters et setters pour l'objet Duree
    function getDuree(){
        return $this->duree; //Retourne en lecture l'objet Duree
    }
    function setDuree($duree){
        $this->duree = $duree; //Permet de determiner une valeur pour l'objet Duree
    }
  
    //Getters et setters pour l'objet Genre
    public function getGenre(){
        return $this->genre; //Retourne en lecture l'objet Genre
    }
    public function setGenre($genre){
        $this->genre = $genre; //Permet de determiner une valeur pour l'objet Genre
    }
  
    //Getters et setters pour l'objet Pays
    public function getPays()
    {
        return $this->pays; //Retourne en lecture l'objet Pays
    }

    public function setPays($pays)
    {
        $this->pays = $pays; //Permet de determiner une valeur pour l'objet Pays
    }

        
    /**
     * @return Collection|Commentaire[]
     */
    public function getCommentaire() : Collection
    {
        return $this->commentaires;
    }

    //Fonction ajout Film qui permet d'ajouter un Commentaire dans un film
    public function addCommentaire(Commentaire $commentaire): self 
    {
        if (!$this->commentaires->contains($commentaire)) {
            $this->commentaires[] = $commentaire;
            $commentaire->setFilm($commentaire);
        }
        return $this;
    }
    //Fonction supprimer Film qui permet de supprimer un commetnaire dans un film
    public function removeCommentaire(Commentaire $commentaire): self 
    {
        if (!$this->commentaires->contains($commentaire)) {
            $this->commentaires->removeElement($commentaire);
            if ($commentaire->getFilm() === $this){
                $commentaire->setFilm(null);  
            }
        }
        return $this;
    }
  
    //methodes 
  
    /**
     * @return Collection|FilmsPersonnes[]
     */
    public function getFilmsPersonnes(): Collection 
    {
        return $this->filmspersonnes;
    }
    
    function setFilmsPersonnes($filmspersonnes) {
        $this->filmspersonnes = $filmspersonnes;
        return $this;
    }
  
  
    public function addFilmsPersonnes(PersonneFilm $filmpersonne): self
    {
        if (!$this->filmspersonnes->contains($filmpersonne)) {
            $this->filmspersonnes[] = $filmpersonne;
            $filmpersonne->setFilm($filmpersonne);
        }
        return $this;
    }
  
    public function removeFilmsPersonnes(PersonneFilm $filmpersonne): self
    {
        if ($this->filmspersonnes->contains($filmpersonne)) {
            $this->filmspersonnes->removeElement($filmpersonne);
            if ($filmpersonne->getFilm() === $this){
                $filmpersonne->setFilm(null);  
            } 
        }
        return $this;
    }
    
}

src/AppBundle/Controller/FilmController.php
<?php

namespace AppBundle\Controller;

/**
 * Les importations 
 */
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\Routing\Annotation\Route;
use Symfony\Component\HttpFoundation\Response;
use Doctrine\Common\Persistence\ObjectManager;

use AppBundle\Entity\Film;
use AppBundle\Entity\Genre;
use AppBundle\Entity\Image;
use AppBundle\Entity\Personne;
use AppBundle\Entity\Pays;
use AppBundle\Entity\Role;
use AppBundle\Entity\Commentaire;
use AppBundle\Entity\Utilisateur;

use AppBundle\Form\CommentaireType;
use AppBundle\Form\UtilisateurType;

use \Symfony\Component\Form\Extension\Core\Type\TextType;
use \Symfony\Component\Form\Extension\Core\Type\UrlType;
use \Symfony\Component\Form\Extension\Core\Type\RadioType;
use \Symfony\Component\Form\Extension\Core\Type\BirthdayType;
use \Symfony\Component\Form\Extension\Core\Type\IntegerType;
use \Symfony\Component\Form\Extension\Core\Type\TextareaType;
use \Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use \Symfony\Component\Form\Extension\Core\Type\SubmitType;
use \Symfony\Bridge\Doctrine\Form\Type\EntityType;

class FilmController extends Controller
{
    
    /**
     * @Route("/film/{id}", name="film")
     * Fonction pour l'affichage d'un film 
     */
    public function filmAction ($id,  Request $request, ObjectManager $manager){
        $em = $this->getDoctrine()->getManager();
        
        $film = new Film();
        $film = $em ->find('AppBundle:Film', $id);
        
        $commentaire = new Commentaire();
        $form = $this->createForm(CommentaireType::class, $commentaire);
        
        $utilisateur = $this->getUser();
        
        $form->handleRequest($request);
        
        if($form->isSubmitted() && $form->isValid()){
            $commentaire->setDateCreation(new \DateTime())
                ->setFilm($film)
                ->setUtilisateur($utilisateur);
            
            $manager->persist($commentaire);
            $manager->flush();
            
            return $this->redirectToRoute('film', ['id'=> $film->getId()]);
        }
        
        return $this->render('@App/Film/film.html.twig', [
            'film' => $film,
            'commentaireForm'=> $form->createView()
        ]);
    }
    
    /**
     * @Route("/ajoutfilm", name="addmovie")
     * @Route("/modiffilm/{id}", name="editfilm")
     * Fonction pour ajouter un film dans la BDD
     */
    public function ajoutfilmAction(Film $addfilm = null, Request $request) {
        //+Object film
        if (!$addfilm){
            $addfilm = new Film();
        }
        
        //FormBuilder
        $formBuilder = $this ->createFormBuilder($addfilm)
                     ->add('titre')
                     ->add('genre', EntityType::class, [
                         'class' => Genre::class,
                         'choice_label' => 'type'
                     ])
                     ->add('pays', EntityType::class, [
                         'class' => Pays::class,
                         'choice_label' => 'nation'
                     ])
                     ->add('annee', TextType::class)
                     ->add('duree', TextType::class)                    
                     ->add('synopsis')
                     ->add('image', UrlType::class);
        
        //FormBuilder generation
        $form = $formBuilder->getForm();
        
        if ($request->isMethod('POST')) { //Verifie la requête
            $form->handleRequest($request);
            if($form->isValid()){
                $em = $this->getDoctrine()->getManager();
                $em->persist($addfilm);
                $em->flush();
                
                $this->get('session')->getFlashBag()->add('Info', 'Film enregiste');
                
                return $this->redirectToRoute('film', ['id' => $addfilm->getId()]);                
            }
        }
        
        //Appel la vue avec le formulaire en parametre
        return $this->render('@App/Film/ajoutfilm.html.twig', [
            'form' => $form -> CreateView(),
            'edit' => $addfilm -> getId() != null
        ]);
        
    }
    
    /**
     * @Route("/liste", name="list")
     * Fonction pour le listage des films
     */
    public function listeAction (){    
        $em = $this->getDoctrine()->getManager();
        $lesfilms  = $em->getRepository('AppBundle:Film')->findall();
        return $this->render('@App/Film/liste.html.twig', array('lesfilms' => $lesfilms)); // Retourne la vue de la page d'accueil
    }
}

src/AppBundle/Resources/views/Film/ajoutfilm.html.twig
{% extends "base.html.twig" %}

{% block title %}
  {% if edit %}
    Modifier un film - CinéFilms
  {% else %}
    Ajout d'un film - CinéFilms
  {% endif %}
{% endblock %}

{% block body %}
  
  <br><br>
      <div class="w3-row w3-container w3-center">
        <div class="w3-large">
          <h1><b>
              {% if edit %}
                Modifier un film
              {% else %}
                Ajouter un film
              {% endif %}
          </b></h1>
        </div>
        <br><br>
            {{ form_start(form) }}    
            <div class="w3-input">
              {{ form_widget(form.titre,{'attr' : {'placeholder' : "Titre du film", 'class' : "w3-input", 'style': "width:20%;" }}) }}
              <br>
                {{ form_widget(form.image,{'attr' : {'placeholder' : "Affiche du film (URL de l'image)", 'class' : "w3-input", 'style': "width:40%;" }}) }}
                <br>                  
                  {{ form_widget(form.annee,{'attr' : {'placeholder' : "Année de sortie du film", 'class' : "w3-input", 'style': "width:20%;" }}) }}
                  <br>
                    {{ form_widget(form.duree,{'attr' : {'placeholder' : "Durée du film (minutes)", 'class' : "w3-input", 'style': "width:20%;" }}) }}
                    <br>
                      {{ form_widget(form.genre, {'attr' : {'class' : "w3-input", 'style': "width:20%;" }}) }}
                      <br>
                        {{ form_widget(form.pays, {'attr' : {'class' : "w3-input", 'style': "width:20%;" }}) }}
                        <br><br>
                            {{ form_widget(form.synopsis,{'attr' : {'placeholder' : "Résumé du film", 'class' : "w3-input", 'style': "width:50%;"  }}) }}   
                            <br><br>
                                <button type="submit" class="w3-button w3-orange w3-hover-black">
                                  {% if edit %}
                                    Enregister les modifications
                                  {% else %}
                                    Ajouter le film
                                  {% endif %}
                                </button>  
                                {{ form_end(form) }}
            </div>
      </div>
      <br>
    {% endblock %}
    

src/AppBundle/Resources/views/Film/ajoutpersonnefilm.html.twig
{% extends "base.html.twig" %}

{% block title %}
  Ajouter des personnes à un film
{% endblock %}

{% block body %}
  
  <br><br>
      <div class="w3-row w3-container w3-center">
        <div class="w3-large">
          <h1><b>
              Associer une personne à un film
          </b></h1>
        </div>
        <br><br>
            {{ form_start(form) }}    
            <div class="w3-input">
              {{ form_widget(form.film,{'attr' : {'placeholder' : "Titre du film", 'class' : "w3-input", 'style': "width:40%;" }}) }}
              <br>
                  {{ form_widget(form.personne,{'attr' : {'placeholder' : "Nom de famille de la personne", 'class' : "w3-input", 'style': "width:30%;" }}) }}
                  <br>
                  <button type="submit" class="w3-button w3-orange w3-hover-black">
                    Associer la personne
                  </button>  
                  {{ form_end(form) }}
            </div>
      </div>
      <br>
        <div class="w3-row w3-container w3-center">
          <div class="w3-large">
            <p><b>
                La personne que vous souhaitez ajouter n'est pas disponible ?<br>
                Ajouter la !
            </b></p>
          </div>
          <br>
            <a href={{ path('ajoutpers') }}>
              <button type="submit" class="w3-button w3-orange w3-hover-black">
                Ajouter la personne
              </button>  
            </a>
        </div>
        <br><br>
      {% endblock %}
      

src/AppBundle/Resources/views/Film/film.html.twig
{% extends "base.html.twig" %}

{% block title %}
  {{film.titre}}
{% endblock %}

{% block body %}
  <br><br>
      <div class="w3-row w3-large w3-center">
        <h1 id="titlefilm"><b>{{ film.titre }}</b></h1>
        <br><br>
      </div>
      
      <div class="w3-row ">
        <div class="w3-center w3-container w3-col m6">
          <a href="{{ film.image }}"><img src="{{ film.image }}" class="w3-round" id="affiche"></a>
        </div>
        <div class=" w3-container w3-col m6">
          <p class="w3-align-left">             
            <b>GENRE :</b> {{ film.genre.type }}<br>
              <b>PAYS :</b> {{ film.pays.nation }}<br>
                <b>ANNEE :</b> {{ film.annee }}<br>
                  <b>DUREE :</b> {{ film.duree }} minutes<br><br><br>
          </p>
          <p class="w3-align-left">
            <b>SYNOPSIS :<br></b> {{ film.synopsis }}
          </p>
        </div>  
      </div>  
      <br><br>
          <div class="w3-row w3-container"> 
            <div class="">
              <h3>
                <b>Equipe du film : </b>
              </h3>
            </div>
            <br><br>
                <div class="w3-row">                    
                    {% for personne in film.filmspersonnes %}                  
                      <div class="w3-center w3-col m2">
                        <img src="{{ personne.personne.image }}" class="personne">
                          <p>{{ personne.personne.prenom }} {{ personne.personne.nom}}<br>{{ personne.personne.role.metier }} </p>
                      </div>
                    {% endfor %}
                  </div>
                 <div class="w3-row">   
                  {% if app.user %}   
                    <div class="w3-container">
                    <a href={{ path('ajoutpersonnefilm') }}>
                      <button class="w3-button w3-orange w3-hover-black" type="submit">
                        Associer une personne
                      </button>
                    </a>
                    </div>
                  {% else %}
                          <div class="w3-container">
                            <p>Pour associer une personne à ce film, vous devez vous connecter !</p>
                              <a href={{ path('connexion') }}>
                                <button class="w3-button w3-orange w3-hover-black">
                                  Se connecter
                                </button>
                              </a>
                          </div>                      
                        {% endif %}
                    </div>
                  </div>
          <br><br>
              <div class="w3-row w3-container" style="background-color:">
                <h3>
                  <b>Commentaires ({{ film.commentaire | length }}): </b>
                </h3><br><br>
                    {% for commentaire in film.commentaire %}
                      <div class="w3-row"> 
                        <ul class="w3-ul">
                          <div class="w3-col m3">  
                            <li>
                              <label>Auteur : <label><br>
                                    <h5>{{ commentaire.utilisateur.username }} : (<small>{{ commentaire.dateCreation | date('d/m/Y à h:i') }}</small>)</h5>
                            </li>
                          </div>
                          <div class="w3-col m9">
                            <li>
                              <label>Son commentaire : <label><br>
                                    <h6>{{ commentaire.contenu }}</h6>
                            </li>   
                          </div>
                        </ul>
                      </div>
                      <br>
                    {% endfor %}
              </div>
              
              <br><br><br><br>
                      <div class="w3-row w3-container" style="background-color: #262626;">
                        {% if app.user %}
                          {{ form_start(commentaireForm) }}
                          <div class="w3-input">
                            <br><br>                             
                                <h4><b>{{ app.user.username }}</b></h4>
                                {{ form_widget(commentaireForm.contenu, {'attr' : {'placeholder' : "Commenter...", 'class' : "w3-input", 'style': "width:70%;" }}) }}
                                <br>
                                    <button class="w3-button w3-orange w3-hover-black" type="submit">
                                      Commenter
                                    </button>
                          </div>
                          {{ form_end(commentaireForm) }}                       
                        {% else %}
                          <div class="w3-center">
                            <h4>Pour commenter, vous devez vous connecter !</h4><br>
                              <a href={{ path('connexion') }}>
                                <button class="w3-button w3-orange w3-hover-black">
                                  Se connecter
                                </button>
                              </a>
                          </div>                      
                        {% endif %}
                        <br>
                      </div>
                      
                    {% endblock %}
                    

src/AppBundle/Resources/views/Film/liste.html.twig
{% extends "base.html.twig" %}

{% block title %}
  Les films - CinéFilms
{% endblock %}

{% block body %}  
  <br><br>
      <div class="w3-row w3-large w3-center">
        <h1><b>Liste des films</b></h1>
      </div>
      <br> 
        <div class="w3-center w3-margin-left">
          <!--
              <h3>
                <div class="w3-row">
                  Filtrer par genre : <br> 
              </h3>
              <div class="">
                <button style="width:8%">Action</button> 
                <button style="width:8%">Comédie</button>
                <button style="width:8%">SF</button>
                <button style="width:8%">Drame</button>
                <button style="width:8%">Aventure</button>
                <button style="width:8%">Horreur</button>
              </div> 
              </div>
              -->
              <div class="w3-row w3-center liste">
                <br><br>
                    <ul class="w3-ul w3-hoverable w3-round-small w3-dark-grey">                   
                      {% if lesfilms is defined %}
                        {% for film in lesfilms %}          
                          <li>
                            <a href="{{path ('film', {'id':film.id}) }}" style="text-decoration: none; height: 10px;">
                              <div class="">{{ film.titre }}</div>
                            </a>
                          </li>
                        {% endfor %}
                      {% else %}
                        Aucun film
                      {% endif %}
                    </ul>        
              </div>
              <br>
            {% endblock %}
            

src/AppBundle/Resources/views/Film/recherche.html.twig
{% extends "base.html.twig" %}

{% block title %}
  Recherche - CinéFilms
{% endblock %}

{% block body %}
  <br><br>
      <div class="w3-row w3-large w3-center">
        <h1><b>Recherche avancée (page non fonctionnelle)</b></h1>
      </div>
      <div class="w3-row w3-center" w3-input>
        <br>
          <form  method="">
            <input placeholder="Annee" id="form">
              <input list="duree" placeholder="Duree (minutes)" id="form">
                <datalist id="duree">
                  <option>60 - 80</option>
                  <option>81 - 100</option>
                  <option>101 - 120</option>
                  <option>121 - 140</option>
                  <option>+ 141</option>
                </datalist>
                <br><br>
                    <center>
                      <input list="genre" placeholder="Genre" class="w3-input w3-mobile" style="width: 20%;">
                        <datalist id="genre">
                          <option>Horreur</option>
                          <option>Comédie</option>
                          <option>Drame</option>
                          <option>Action</option>
                          <option>Aventure</option>
                          <option>SF</option>
                        </datalist>
                    </center>
                    <input list="pays" placeholder="Pays" id="form">
                      <datalist id="pays">
                        <option>Français</option>
                        <option>Etats-Unis</option>
                        <option>Espagne</option>
                        <option>Japon</option>
                        <option>Angleterre</option>
                      </datalist>
                      <br><br><br>
                            <input type="submit" value="Valider" id="submit" style="position-right: 10px">
          </form>  
      </div>
      <br>
    {% endblock %}
    